import greenfoot.*;

/**
 * This is the guy you play as throughout the game. Be warned you will not always be this version of the character as he is usless without a gun
 * 
 * @author (Kieran Lewis) 
 * @version (Pre Alpha)
 */
public class DaveNoGun extends Actor
{
    /**
     * Act - do whatever the DaveNoGun wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private GreenfootImage up = new GreenfootImage("DaveBackNoGun.png");
    private GreenfootImage down = new GreenfootImage("DaveFrontNoGun.png");
    private GreenfootImage left = new GreenfootImage("DaveLeftNoGun.png");
    private GreenfootImage right = new GreenfootImage("DaveRightNoGun.png");
    private int prevX;
    private int prevY;
    private int health = 6;
    private GreenfootSound GFG = new GreenfootSound("nogun.mp3");
    private GreenfootSound NICE = new GreenfootSound("ObjectPickup.mp3");
    public void act() 
    {
       move();
       changeDirection();
       Sprint();
       RemoveGun();
       if (getWorld() == null) return;
       ChairCollision();
       storeCurrentPosition();
       noHealth();
       noGunYet();
    }


 public void setHealth(int points)
    {
        health += points;
    }
    public int getHealth()
    {
        return health;
    }
    public void noHealth()
    {
        if (health == 0)
        {
            getWorld().removeObject(this);
            Greenfoot.setWorld(new StartMenu());
        }
    }

    public void move()
    {
         int y = getY();
         int x = getX();
        if (Greenfoot.isKeyDown("up"))
        {
            //This moves Dave up and makes him face forward
            setLocation(x, y-2);
            setImage(up);
        }
        else if (Greenfoot.isKeyDown("Down"))
        {
            //This moves Dave down and makes him face backwards
            setLocation (x, y+2);
            setImage(down);
    } 
        else if (Greenfoot.isKeyDown("left"))
        {
            //this moves Dave left and makes him face his left side
            setLocation(x-2, y);
            setImage(left);
        }
        else if (Greenfoot.isKeyDown("right"))
        {
            //this moves Dave right and makes him face his right side
            setLocation(x+2, y);
            setImage(right);
        }
        
 }
    

    
    public void changeDirection()
    {
    if (Greenfoot.isKeyDown("w"))
    {
        setImage(up);
    }
    else  if (Greenfoot.isKeyDown("s"))
    {
        setImage(down);
    }
    else if (Greenfoot.isKeyDown("a"))
    {
        setImage(left);
    }
    else if (Greenfoot.isKeyDown("d"))
    {
        setImage(right);
    }

}

    public void Sprint()
    
    {
        int y = getY();
        int x = getX();
        if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("up"))
        {
            setLocation(x, y-4);
            setImage(up);
        }
               else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("Down"))
        {
            //This moves Dave down and makes him face backwards
            setLocation (x, y+4);
            setImage(down);
        } 
        else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("left"))
        {
            //this moves Dave left and makes him face his left side
            setLocation(x-4, y);
            setImage(left);
        }
        else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("right"))
        {
            //this moves Dave right and makes him face his right side
            setLocation(x+4, y);
            setImage(right);
        }
}
    public void RemoveGun()
    
    {
        if(!getObjectsInRange(50, XMPR3.class) .isEmpty())
        {
            XMPR3 XM = (XMPR3) getOneIntersectingObject(XMPR3.class); 
            getWorld().removeObject(XM);
            getWorld().addObject(new DaveLV1(), 850, 150);
            getWorld().removeObject(this);
            NICE.play();
        }
}
    public void ChairCollision()

        {
        if(!getObjectsInRange(50, Chair.class) .isEmpty())
        {
            setLocation(prevX ,prevY);   
        }
        
       
}

private void storeCurrentPosition()
   {
       prevX = getX();
       prevY = getY();
}//end of method store current position

public void noGunYet()
{
    if(Greenfoot.isKeyDown("space")) GFG.play();
    
}

}






