import greenfoot.*;

/**
 * Write a description of class AtrixoLV2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AtrixoLV2 extends Actor
{
    private GreenfootImage up = new GreenfootImage("AtrixoLV2Back.png");
    private GreenfootImage down = new GreenfootImage("AtrixoLV2Front.png");
    private GreenfootImage left = new GreenfootImage("AtrixoLV2Left.png");
    private GreenfootImage right = new GreenfootImage("AtrixoLV2Right.png");
    private int movingCounter = 0;
    private int shotDelay = 0;
    //RNG = random number generator
    private int RNG = Greenfoot.getRandomNumber(3);
    private int prevX;
    private int prevY;
    private int health = 3;
    private GreenfootSound AH = new GreenfootSound("Atrixohit.mp3");
   
    public void act() 
    {
        // Add your action code here.
        checkMove();
        chairCollision();
        storeCurrentPosition();
        atrixoLV1Shoot();
        noHealth();
    }    
    
    
    public void setHealth(int points)
    {
        health += points;
    }
    public int getHealth()
    {
        return health;
    }
    public void noHealth()
    {
        if (health == 0)
        {
            World myWorld1 = getWorld();
            Jungle Jg = (Jungle)myWorld1;
            KillCount1 kc1 = Jg.getKillCount1();
            kc1.incDead1();
            getWorld().removeObject(this);
            AH.play();
        }
    }
    public void checkMove()
    {
      
     if (movingCounter < 20)
    
    {
     setLocation(getX() + 2, getY());
     setImage(right);
     
    }
    else if (movingCounter < 60)
    {
        setLocation(getX() -2, getY());
        setImage(left);
    }
    else if (movingCounter < 120)
    {
        setLocation(getX(), getY() +2);
        setImage(down);
    }
    else if (movingCounter < 160)
    {
        setLocation(getX(), getY() -2);
        setImage(up);
    }
        
    else 
    {
        movingCounter = 0;
    }
    movingCounter++;
    
}

public void chairCollision()

{
     if(!getObjectsInRange(50, Chair.class) .isEmpty())
            setLocation(prevX ,prevY);           
}

private void storeCurrentPosition()
   {
       prevX = getX();
       prevY = getY();
    }//end of method store current position
    public void atrixoLV1Shoot()
    {
        PlasmaE plasmaE = new PlasmaE();
        
       
        if (shotDelay <= 10 && shotDelay < RNG && getImage().equals(right) && getWorld().getObjects(PlasmaE.class).isEmpty())
        {
           //plasmaE.move(getImage().getWidth() / -2);
             getWorld().addObject(plasmaE, getX(), getY());
             
           
        
    }
    
     else if(shotDelay  <=20 && shotDelay < RNG && getImage().equals(left)&& getWorld().getObjects(PlasmaE.class).isEmpty())
    
           
        {
            getWorld().addObject(plasmaE, getX(), getY());
            plasmaE.move(getImage().getWidth() / -2);
            plasmaE.setRotation(180);
        }
        
    else if (shotDelay <= 30 && shotDelay < RNG && getImage().equals(up)&& getWorld().getObjects(PlasmaE.class).isEmpty())
    {
        getWorld().addObject(plasmaE, getX(), getY());
        plasmaE.move(getImage().getHeight() /6);
        plasmaE.setRotation(270);
    }
        
    else if (shotDelay <=40 && shotDelay < RNG && getImage().equals(down)&& getWorld().getObjects(PlasmaE.class).isEmpty())
    {
        getWorld().addObject(plasmaE, getX(), getY());
        plasmaE.move(getImage().getWidth() / -5);
        plasmaE.setRotation(90);
    }
        
        
    else
    {
        shotDelay = 0;
    }
    shotDelay++;
}

}
