import greenfoot.*;

/**
 * This is Dave with his gun. He is actually competent now since he has a gun, now go kill those damn aliens.
 * 
 * @author (Kieran Lewis) 
 * @version (Pre Alpha)
 */
public class DaveLV1 extends Actor
{
    /**
     * Act - do whatever the DaveLV1 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private GreenfootImage up = new GreenfootImage("DaveBackLV1.png");
    private GreenfootImage down = new GreenfootImage("DaveFrontLV1.png");
    private GreenfootImage left = new GreenfootImage("DaveLeftLV1.png");
    private GreenfootImage right = new GreenfootImage("DaveRightLV1.png");
    private boolean spaceDown;
    private int prevX;
    private int prevY;
    private int ammo = 60;
    private int health = 6;
    private GreenfootSound PS = new GreenfootSound("plasmashot.mp3");
    private GreenfootSound NA = new GreenfootSound("noammo.mp3"); 
    private GreenfootSound PU = new GreenfootSound("Pickup.mp3");
    public void act() 
    {
       move();
       changeDirection();
       Sprint();
       fire();
       ChairCollision();
       storeCurrentPosition();
       
       exitCollision();
       morePlasma();
}
 public void setHealth(int points)
    {
        health += points;
    }
    public int getHealth()
    {
        return health;
    }
    public void noHealth()
    {
        if (health == 0)
        { 
            getWorld().removeObject(this);
            Greenfoot.setWorld(new StartMenu());
        }
    }

    public void move()
    {
        int y = getY();
        int x = getX();
         if (Greenfoot.isKeyDown("up"))
        {
            //This moves Dave up and makes him face forward
            setLocation(x, y-2);
            setImage(up);
        }
        else if (Greenfoot.isKeyDown("Down"))
        {
            //This moves Dave down and makes him face backwards
            setLocation (x, y+2);
            setImage(down);
    } 
        else if (Greenfoot.isKeyDown("left"))
        {
            //this moves Dave left and makes him face his left side
            setLocation(x-2, y);
            setImage(left);
        }
        else if (Greenfoot.isKeyDown("right"))
        {
            //this moves Dave right and makes him face his right side
            setLocation(x+2, y);
            setImage(right);
        }
        
        
}
    

    
    public void changeDirection()
    {             
    if (Greenfoot.isKeyDown("w"))
    {
        setImage(up);
        
    }
    else  if (Greenfoot.isKeyDown("s"))
    {
        setImage(down);
    }
    else if (Greenfoot.isKeyDown("a"))
    {
        setImage(left);
    }
    else if (Greenfoot.isKeyDown("d"))
    {
        setImage(right);
    }

}

    public void Sprint()
    
    {
        int y = getY();
        int x = getX();
        
         if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("up"))
        {
            //This moves Dave up and makes him face forward
            setLocation(x, y-3);
            setImage(up);
        }
               else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("Down"))
        {
            //This moves Dave down and makes him face backwards
            setLocation (x, y+3);
            setImage(down);
        } 
        else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("left"))
        {
            //this moves Dave left and makes him face his left side
            setLocation(x-3, y);
            setImage(left);
        }
        else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("right"))
        {
            //this moves Dave right and makes him face his right side
            setLocation(x+3, y);
            setImage(right);
        }
}

 public void fire()
 
 
    {
    int setRotation;
     World myWorld1 = getWorld();
    SpaceStation SS1 = (SpaceStation)myWorld1;
    ammoLV1 amm1 = SS1.getammoLV1();
   if (!spaceDown && Greenfoot.isKeyDown("space") && amm1.ammo1 >0 && getWorld().getObjects(Plasma.class).isEmpty())
   
   {
   
    World myWorld = getWorld();
    SpaceStation SS = (SpaceStation)myWorld;
    ammoLV1 am1 = SS.getammoLV1();
    am1.decAMMO1();
    PS.play();
    spaceDown = true;
    Plasma plasma = new Plasma();
    getWorld().addObject(plasma, getX(), getY());
    
   
    
    //   AMMO ammo = space.getAMMO();
    //   ammo.decreaseAMMO();
    
    if (getImage().equals(left)) 
    {
        
        plasma.move(getImage().getHeight() / -2);
        //this will rotate the plasma round 180 degrees
        plasma.setRotation(180);
    }  
  
    else if (getImage().equals(up)) 
    {
        plasma.move(getImage().getHeight() / 6);
        //this will rotate the plasma round 270 degrees
        plasma.setRotation(270);
    }
    else if (getImage().equals(right)) 
    {
        plasma.move(getImage().getWidth() / 2);
        //this wont change the plasmas rotation
        plasma.setRotation(0);
    }
    
    else 
    {
        plasma.move(getImage().getWidth() / -5);
        //this will rotate the plasma round 90 degrees
        plasma.setRotation(90);
    }


    }

    if (!spaceDown && Greenfoot.isKeyDown("space") && amm1.ammo1 ==0)
    {
        NA.play();
    }
  
    if (spaceDown && !Greenfoot.isKeyDown("space"))

    {
        spaceDown = false;
        
    }
}

public void ChairCollision()

{
     if(!getObjectsInRange(50, Chair.class) .isEmpty())
            setLocation(prevX ,prevY);           
}

private void storeCurrentPosition()
   {
       prevX = getX();
       prevY = getY();
    }//end of method store current position
    



    public void exitCollision()
    {

        {
            if(!getObjectsInRange(50, SpaceStationExit.class) .isEmpty())
                Greenfoot.setWorld(new Mission1Ending());       
        }
}

  public void morePlasma()
    {

        {
            
            World myWorld1 = getWorld();
            SpaceStation SS = (SpaceStation)myWorld1;
            ammoLV1 aml1 = SS.getammoLV1();
            
          
             if(!getObjectsInRange(50, plasmaKit.class) .isEmpty())
            
           
              {
                  plasmaKit pK = (plasmaKit) getOneIntersectingObject(plasmaKit.class);
                  getWorld().removeObject(pK);
                  aml1.incAMMO1();
                  PU.play();
               }
        
    
}

}
}




