import greenfoot.*;

/**
 * Write a description of class DaveLV2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class DaveLV2 extends Actor
{
    /**
     * Act - do whatever the DaveLV wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private GreenfootImage up = new GreenfootImage("DaveBackLV2.png");
    private GreenfootImage down = new GreenfootImage("DaveFrontLV2.png");
    private GreenfootImage left = new GreenfootImage("DaveLeftLV2.png");
    private GreenfootImage right = new GreenfootImage("DaveRightLV2.png");
    private boolean spaceDown;
    private int prevX;
    private int prevY;
    private int ammo = 100;
    
    private GreenfootSound PS2 = new GreenfootSound("plasmaShot2.mp3");
     private GreenfootSound NA = new GreenfootSound("noammo.mp3"); 
    private GreenfootSound PU = new GreenfootSound("Pickup.mp3");
     public void act() 
    {
       move();
       changeDirection();
       Sprint();
       fire();
       treeCollision();
       storeCurrentPosition();
       morePlasma();
       exit2Collision();
}

//  public void setHealth(int points)
//     {
//         health += points;
//     }
//     public int getHealth()
//     {
//         return health;
//     }
//     public void noHealth()
//     {
//         if (health == 0)
//         {
//             getWorld().removeObject(this);
//             Greenfoot.setWorld(new StartMenu());
//         }
//     }

    public void move()
    {
         int y = getY();
        int x = getX();
       if (Greenfoot.isKeyDown("up"))
        {
            //This moves Dave up and makes him face forward
            setLocation(x, y-2);
            setImage(up);
        }
        else if (Greenfoot.isKeyDown("Down"))
        {
            //This moves Dave down and makes him face backwards
            setLocation (x, y+2);
            setImage(down);
    } 
        else if (Greenfoot.isKeyDown("left"))
        {
            //this moves Dave left and makes him face his left side
            setLocation(x-2, y);
            setImage(left);
        }
        else if (Greenfoot.isKeyDown("right"))
        {
            //this moves Dave right and makes him face his right side
            setLocation(x+2, y);
            setImage(right);
        }
        
    }
    

    
    public void changeDirection()
    {
    if (Greenfoot.isKeyDown("w"))
    {
        setImage(up);
        
    }
    else  if (Greenfoot.isKeyDown("s"))
    {
        setImage(down);
    }
    else if (Greenfoot.isKeyDown("a"))
    {
        setImage(left);
    }
    else if (Greenfoot.isKeyDown("d"))
    {
        setImage(right);
    }

}

    public void Sprint()
    
    {
        int y = getY();
        int x = getX();
        
        if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("up"))
        {
            setLocation(x, y-4);
            setImage(up);
        }
               else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("Down"))
        {
            //This moves Dave down and makes him face backwards
            setLocation (x, y+4);
            setImage(down);
        } 
        else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("left"))
        {
            //this moves Dave left and makes him face his left side
            setLocation(x-4, y);
            setImage(left);
        }
        else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("right"))
        {
            //this moves Dave right and makes him face his right side
            setLocation(x+4, y);
            setImage(right);
        }
}

 public void fire()
 
 
{
    int setRotation;
    
       World myWorld1 = getWorld();
    Jungle JJ2 = (Jungle)myWorld1;
    ammoLV2 am2 = JJ2.getammoLV2();
  if (!spaceDown && Greenfoot.isKeyDown("space") && am2.ammo2 >0)
   {
     spaceDown = true;
     
     World myWorld2 = getWorld();
    Jungle J2 = (Jungle)myWorld1;
    ammoLV2 amm2 = J2.getammoLV2();
    amm2.decAMMO2();
    Plasma plasma = new Plasma();
    getWorld().addObject(plasma, getX(), getY());
    PS2.play();
  if (getImage().equals(left)) 
    {
        
        plasma.move(getImage().getHeight() / -2);
        plasma.setRotation(180);
    }  
  
    else if (getImage().equals(up)) 
    {
        plasma.move(getImage().getHeight() / 6);
        plasma.setRotation(270);
    }
    else if (getImage().equals(right)) 
    {
        plasma.move(getImage().getWidth() / 2);
        plasma.setRotation(0);
    }
    
    else 
    {
        plasma.move(getImage().getWidth() / -5);
        plasma.setRotation(90);
    }
}

if (!spaceDown && Greenfoot.isKeyDown("space") && am2.ammo2 ==0)
{
    NA.play();
}

if (spaceDown && !Greenfoot.isKeyDown("space"))

{
    spaceDown = false;
    
}
}
public void treeCollision()
{
    if(!getObjectsInRange(35, Tree.class) .isEmpty())
            setLocation(prevX, prevY);
}

private void storeCurrentPosition()
{
    prevX = getX();
    prevY = getY();
}

  public void morePlasma()
    {

        {
            
            World myWorld1 = getWorld();
            Jungle JJ2 = (Jungle)myWorld1;
            ammoLV2 aml2 = JJ2.getammoLV2();
            
             if(!getObjectsInRange(50, plasmaKit.class) .isEmpty())
            
           
              {
                  plasmaKit pK2 = (plasmaKit) getOneIntersectingObject(plasmaKit.class);
                  getWorld().removeObject(pK2);
                  aml2.incAMMO2();
                  PU.play();
               }
        
    
}

}

 public void exit2Collision()
    {

        {
            if(!getObjectsInRange(50, AlienShipExit.class) .isEmpty())
                Greenfoot.setWorld(new Mission2Ending());       
        }
}
}
