import greenfoot.*;

/**
 * Write a description of class DaveLV3 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class DaveLV3 extends Actor
{
    /**
     * Act - do whatever the DaveLV3 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private GreenfootImage up = new GreenfootImage("DaveBackLV3.png");
    private GreenfootImage down = new GreenfootImage("DaveFrontLV3.png");
    private GreenfootImage left = new GreenfootImage("DaveLeftLV3.png");
    private GreenfootImage right = new GreenfootImage("DaveRightLV3.png");
    private int prevX;
    private int prevY;
    private int ammo = 160;
    private int health = 3;
    private GreenfootSound PU = new GreenfootSound("Pickup.mp3");
    private GreenfootSound PS = new GreenfootSound("plasmaAuto.mp3");
    private GreenfootSound MBU = new GreenfootSound("MorixoBlownUp.mp3");
    public void act() 
    {
       move();
       changeDirection();
       Sprint();
       fire();
       Building1Collision();
       Building2Collision();
       storeCurrentPosition();
       morePlasma();
       exit3Collision();
}

 public void setHealth(int points)
    {
        health += points;
    }
    public int getHealth()
    {
        return health;
    }
    public void noHealth()
    {
        if (health == 0)
        {
            getWorld().removeObject(this);
            Greenfoot.setWorld(new StartMenu());
        }
    }

    public void move()
    {
         int y = getY();
        int x = getX();
      if (Greenfoot.isKeyDown("up"))
        {
            //This moves Dave up and makes him face forward
            setLocation(x, y-2);
            setImage(up);
        }
        else if (Greenfoot.isKeyDown("Down"))
        {
            //This moves Dave down and makes him face backwards
            setLocation (x, y+2);
            setImage(down);
    } 
        else if (Greenfoot.isKeyDown("left"))
        {
            //this moves Dave left and makes him face his left side
            setLocation(x-2, y);
            setImage(left);
        }
        else if (Greenfoot.isKeyDown("right"))
        {
            //this moves Dave right and makes him face his right side
            setLocation(x+2, y);
            setImage(right);
        }
        
        
    }
    

    
    public void changeDirection()
    {
    if (Greenfoot.isKeyDown("w"))
    {
        setImage(up);
        
    }
    else  if (Greenfoot.isKeyDown("s"))
    {
        setImage(down);
    }
    else if (Greenfoot.isKeyDown("a"))
    {
        setImage(left);
    }
    else if (Greenfoot.isKeyDown("d"))
    {
        setImage(right);
    }

}

    public void Sprint()
    
    {
        int y = getY();
        int x = getX();
        
       if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("up"))
        {
            setLocation(x, y-4);
            setImage(up);
        }
               else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("Down"))
        {
            //This moves Dave down and makes him face backwards
            setLocation (x, y+4);
            setImage(down);
        } 
        else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("left"))
        {
            //this moves Dave left and makes him face his left side
            setLocation(x-4, y);
            setImage(left);
        }
        else if (Greenfoot.isKeyDown("shift") && Greenfoot.isKeyDown("right"))
        {
            //this moves Dave right and makes him face his right side
            setLocation(x+4, y);
            setImage(right);
        }
        
}

 public void fire()
 
 
{
    int setRotation;
  
    World myWorld3 = getWorld();
    Morixo MX = (Morixo)myWorld3;
    ammoLV3 amm3 = MX.getammoLV3();
    
  if (Greenfoot.isKeyDown("space")&& amm3.ammo3>0 && getWorld().getObjects(Plasma.class).isEmpty())
   {
     
    World myWorld = getWorld();
    Morixo MX1 = (Morixo)myWorld;
    ammoLV3 am3 = MX1.getammoLV3();
    am3.decAMMO3();
    Plasma plasma = new Plasma();
    getWorld().addObject(plasma, getX(), getY());
    PS.play();
   if (getImage().equals(left)) 
    {
        plasma.move(getImage().getWidth() /-12);
        plasma.move(getImage().getHeight() / -2);
        plasma.setRotation(180);
    }  
  
    else if (getImage().equals(up)) 
    {
        plasma.move(getImage().getHeight() / 6);
        plasma.setRotation(270);
    }
    else if (getImage().equals(right)) 
    {
        plasma.move(getImage().getWidth() / 2);
        plasma.setRotation(0);
    }
    
    else 
    {
        plasma.move(getImage().getWidth() / -5);
        plasma.setRotation(90);
    }
    }
    

}
public void Building1Collision()

{
     if(!getObjectsInRange(70, MorixoBuilding1.class) .isEmpty())
            setLocation(prevX ,prevY);           
}

public void  Building2Collision()

{
     if(!getObjectsInRange(70, MorixoBuilding2.class) .isEmpty())
            setLocation(prevX ,prevY);           
}

private void storeCurrentPosition()
{
    prevX = getX();
    prevY = getY();
}

public void morePlasma()
    {

        
    
                  
            World myWorld1 = getWorld();
            Morixo MX = (Morixo)myWorld1;
            ammoLV3 aml3 = MX.getammoLV3();
            
             if(!getObjectsInRange(50, plasmaKit.class) .isEmpty())
            
           
              {
                  plasmaKit pK3 = (plasmaKit) getOneIntersectingObject(plasmaKit.class);
                  getWorld().removeObject(pK3);
                  aml3.incAMMO3();
                  PU.play();
               }
        
    
}

public void exit3Collision()
{
    
        
            if(!getObjectsInRange(50, Detonator.class).isEmpty())
                {
                    Greenfoot.setWorld(new Mission3Ending());     
                    MBU.play();
                }
        }
}






