import greenfoot.*;

/**
 * Write a description of class Trixie here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Trixie extends Actor
{
    /**
     * Act - do whatever the Trixie wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    private int health = 15;
    private int direction = 1-2*Greenfoot.getRandomNumber(2); // This will allow Trixe to move in a random direction
    private int timer=0;
    private int speed = 1;
    private GreenfootSound TD = new GreenfootSound("TrixieDead.mp3");
    public void act()
    { 
        if (getWorld() == null) return;
        noHealth();
        bossShoot();
        if (getWorld() == null) return;
        setLocation((getX()+getWorld().getWidth()+speed*direction)%getWorld().getWidth(), getY());
        if (getWorld() == null) return;
    }
    
    
   
    
    public void setHealth(int points)
    {
        health += points;
    }
    public int getHealth()
    {
        return health;
    }
    public void noHealth()
    {
        if (health == 0)
        {
            World myWorld1 = getWorld();
            SpaceStation SS = (SpaceStation)myWorld1;
            KillCount1 kc1 = SS.getKillCount1();
            kc1.incDead1();
            getWorld().removeObject(this);
            TD.play();
            
        }
    }
    
    public void bossShoot()
    {
        PlasmaE plasmaE = new PlasmaE();
        
        if(timer>0)timer--;
        
        if(timer==0)
        {
            if (getWorld() == null) return;
             getWorld().addObject(plasmaE, getX(), getY());
             plasmaE.move(getImage().getWidth() / -5);
             plasmaE.setRotation(90);
             timer=30;
        }
        
    
    }
}

